function [xout, yout, dout, change] = CircUpdate(xin, yin, din)
% CircUpdate Perform one step of the circle computation
%
% CircUpdate updates variables x, y, d do compute one point of a circle
% 
% Inpus/Outputs: 
% xin/xout, yin/yout - x and y coordinate of the point
% din/dout - auxiliary variable
%
% Author Jan Schier <schier@utia.cas.cz>
% Date 2009/08/04
% 
% Copyright
% (c) 2009 Dept. of Signal Processing
% Institute of Information Theory and Automation
% Academy of Sciences of the Czech Republic, Prague
%
% http://sp.utia.cz
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% You are free to distribute this software under Version 2.1
% of the GNU General Public License.

if din < 0
    dout = din + 2*xin + 3;
    xout = xin + 1;
    yout = yin;
    if nargout==4
        change=0;
    end
else
    dout = din + 2*(xin-yin) + 5;
    xout = xin + 1;
    yout = yin - 1;
    if nargout==4
        change=1;
    end
end
end
